## OAuth 文档

关于OAuth2相关的内容、原理可以自行参阅以下资料：

- [The OAuth 2.0 Authorization Framework](https://tools.ietf.org/html/rfc6749)
- [OAuth 2.0](https://oauth.net/2/)

## 第三方平台的API文档

- <a href="https://gitee.com/api/v5/oauth_doc#list_1" target="_blank">Gitee</a>
- <a href="https://developer.github.com/apps/building-oauth-apps/authorizing-oauth-apps/" target="_blank">Github</a>
- <a href="https://open.weibo.com/wiki/%E6%8E%88%E6%9D%83%E6%9C%BA%E5%88%B6%E8%AF%B4%E6%98%8E" target="_blank">新浪微博</a>
- <a href="https://open-doc.dingtalk.com/microapp/serverapi2/kymkv6" target="_blank">钉钉</a>
- <a href="http://developer.baidu.com/wiki/index.php?title=docs/oauth" target="_blank">百度</a> 
- <a href="https://open.coding.net/references/oauth/" target="_blank">coding</a>
- <a href="https://dev.tencent.com/help/doc/faq/b4e5b7aee786/oauth" target="_blank">腾讯云</a>
- <a href="https://www.oschina.net/openapi/docs/oauth2_authorize" target="_blank">开源中国</a>
- <a href="https://alipay.open.taobao.com/docs/doc.htm?spm=a219a.7629140.0.0.336d4b70GUKXOl&treeId=193&articleId=105809&docType=1" target="_blank">支付宝</a>
- <a href="https://wiki.connect.qq.com/%E4%BD%BF%E7%94%A8authorization_code%E8%8E%B7%E5%8F%96access_token" target="_blank">QQ</a> 
- <a href="https://open.weixin.qq.com/cgi-bin/showdocument?action=dir_list&t=resource/res_list&verify=1&id=open1419316505&token=&lang=zh_CN" target="_blank">微信开放平台</a> 
- <a href="https://developers.weixin.qq.com/doc/offiaccount/OA_Web_Apps/Wechat_webpage_authorization.html" target="_blank">微信公众平台</a>
- <a href="https://open.work.weixin.qq.com/api/doc#90000/90135/90664" target="_blank">企业微信</a>
- <a href="https://open.taobao.com/doc.htm?spm=a219a.7386797.0.0.4e00669acnkQy6&source=search&docId=105590&docType=1" target="_blank">淘宝</a> 
- <a href="https://developers.google.com/identity/protocols/OpenIDConnect" target="_blank">Google</a> 
- <a href="https://developers.facebook.com/docs/facebook-login/manually-build-a-login-flow" target="_blank">Facebook</a> 
- <a href="https://www.douyin.com/platform/doc/m-2-1-1" target="_blank">抖音</a> 
- <a href="https://docs.microsoft.com/zh-cn/linkedin/shared/authentication/authorization-code-flow?context=linkedin/context" target="_blank">领英</a>
    - <a href="https://docs.microsoft.com/zh-cn/linkedin/shared/authentication/authorization-code-flow?context=linkedin/context" target="_blank">Sign In with LinkedIn</a> 
- <a href="https://docs.microsoft.com/zh-cn/graph/auth-v2-user" target="_blank">微软</a>
- <a href="https://dev.mi.com/console/doc/detail?pId=711" target="_blank">小米</a>
- <a href="https://open.mp.toutiao.com/#/resource?_k=y7mfgk" target="_blank">头条</a>
- <a href="https://docs.teambition.com/" target="_blank">Teambition</a>
- <a href="http://open.renren.com/wiki/OAuth2.0" target="_blank">人人</a>
- <a href="https://developers.pinterest.com/docs/api/overview/?" target="_blank">Pinterest</a>
- <a href="https://api.stackexchange.com/docs/authentication" target="_blank">StackOverflow</a>
- <a href="https://developer.huawei.com/consumer/cn/devservice/doc/30101" target="_blank">华为</a>
- <a href="https://open.kujiale.com/open/apps/2/docs?doc_id=95" target="_blank">酷家乐</a>
- <a href="https://docs.gitlab.com/ee/api/oauth2.html" target="_blank">Gitlab</a>
- <a href="http://open.waimai.meituan.com/openapi_docs/oauth/" target="_blank">美团</a>
- <a href="https://open.shop.ele.me/openapi/documents/khd001" target="_blank">饿了么</a>
- <a href="https://developer.twitter.com/en/docs/basics/authentication/guides/log-in-with-twitter" target="_blank">推特</a>
    - <a href="https://developer.twitter.com/en/docs/tweets/data-dictionary/overview/user-object" target="_blank">用户信息</a>
    - <a href="https://developer.twitter.com/en/docs/basics/response-codes" target="_blank">响应码</a>
    - <a href="https://developer.twitter.com/en/docs/basics/apps/guides/callback-urls" target="_blank">Callback Urls规则</a>
- <a href="https://help.aliyun.com/document_detail/93696.html?spm=a2c4g.11186623.6.656.1a764138vhg4gr" target="_blank">阿里云</a>
    - [Web应用登录阿里云](https://help.aliyun.com/document_detail/93696.html?spm=a2c4g.11186623.6.656.1a764138vhg4gr)
    - [通过OIDC获取用户信息](https://help.aliyun.com/document_detail/93698.html?spm=a2c4g.11186623.6.658.537dd19eE1eEJh)
- <a href="https://open.jd.com/home/home#/doc/common?listId=880" target="_blank">京东·宙斯</a>